## mankalaengine 1.1.0+p24.04+vunstable+git20260103.0740

=== CMakeLists.txt ===
#=============================================================================
# SPDX-FileCopyrightText: 2024 João Gouveia <jtalonegouveia@gmail.com>
# SPDX-FileCopyrightText: 2025 Srisharan V S <srisharan.psgtech@gmail.com>
#
# SPDX-License-Identifier: GPL-3.0-or-later
#=============================================================================

cmake_minimum_required(VERSION 3.23)

project(
    MankalaEngine
    VERSION 1.1
    DESCRIPTION "Engine used for creating computerized opponents for Mancala variants."
    LANGUAGES CXX)

find_package(Qt6 COMPONENTS Test)

find_package(ECM 6.0 REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})

include(KDEInstallDirs6)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(KDECMakeSettings NO_POLICY_SCOPE)
include(ECMMarkNonGuiExecutable)

set(CMAKE_EXPORT_COMPILE_COMMANDS TRUE)

if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME)
    set(IS_PROJECT TRUE)
else()
    set(IS_PROJECT FALSE)
endif()

option(BUILD_TESTING "Build the tests" ${IS_PROJECT})
option(BUILD_DOCS "Build the docs" ${IS_PROJECT})
option(BUILD_EXAMPLES "Build the examples" ${IS_PROJECT})
option(BUILD_BENCHMARK "Build the engine comparison utility" ${IS_PROJECT})
option(BUILD_LINTING "Run the linting utilities when building" ${IS_PROJECT})

if (${IS_PROJECT} AND BUILD_LINTING)
    find_program(CLANG_TIDY NAMES "clang-tidy")
    if(CLANG_TIDY)
        set(CLANG_TIDY_COMMAND "${CLANG_TIDY}" "-p" "${CMAKE_BINARY_DIR}")
    endif()
endif()

if(${IS_PROJECT} AND BUILD_TESTING AND Qt6_FOUND)
    add_subdirectory(test)
endif()

if(${IS_PROJECT} AND BUILD_BENCHMARK)
    add_subdirectory(benchmark)
endif()

if(${IS_PROJECT} AND BUILD_EXAMPLES)
    add_subdirectory(examples)
endif()

if(${IS_PROJECT} AND BUILD_DOCS)
    add_subdirectory(docs)
endif()

add_subdirectory(src)

=== benchmark/CMakeLists.txt ===
#=============================================================================
# SPDX-FileCopyrightText: 2024 João Gouveia <jtalonegouveia@gmail.com>
#
# SPDX-License-Identifier: GPL-3.0-or-later
#=============================================================================

add_executable(benchmark benchmark.cpp)
target_link_libraries(benchmark PRIVATE MankalaEngine)

target_include_directories(benchmark PUBLIC ../include/mankalaengine)
ecm_mark_nongui_executable(benchmark)

=== docs/CMakeLists.txt ===
#=============================================================================
# SPDX-FileCopyrightText: 2024 João Gouveia <jtalonegouveia@gmail.com>
#
# SPDX-License-Identifier: GPL-3.0-or-later
#=============================================================================

find_package(Doxygen)
if (DOXYGEN_FOUND)
    set(DOXYGEN_IN ${CMAKE_SOURCE_DIR}/docs/Doxyfile.in)
    set(DOXYGEN_OUT ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)

    configure_file(${DOXYGEN_IN} ${DOXYGEN_OUT} @ONLY)

    add_custom_target(docs ALL
        COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYGEN_OUT}
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
else (DOXYGEN_FOUND)
    message("Building the docs requires Doxygen installed")
endif (DOXYGEN_FOUND)

=== examples/CMakeLists.txt ===
#=============================================================================
# SPDX-FileCopyrightText: 2024 João Gouveia <jtalonegouveia@gmail.com>
# SPDX-FileCopyrightText: 2025 Srisharan V S <srisharan.psgtech@gmail.com>
#
# SPDX-License-Identifier: GPL-3.0-or-later
#=============================================================================

file(GLOB_RECURSE EXAMPLES *.cpp)
if(BUILD_EXAMPLES)
    foreach(example_src ${EXAMPLES})
        get_filename_component(example_name ${example_src} NAME_WE)

        add_executable(${example_name} ${example_src})
        target_link_libraries(${example_name} PRIVATE MankalaEngine)

        target_include_directories(${example_name} PUBLIC ../include/mankalaengine)
        ecm_mark_nongui_executable(${example_name})
        install(TARGETS ${example_name} RUNTIME DESTINATION bin)
    endforeach()
endif()

=== src/CMakeLists.txt ===
#=============================================================================
# SPDX-FileCopyrightText: 2024 João Gouveia <jtalonegouveia@gmail.com>
# SPDX-FileCopyrightText: 2025 Srisharan V S <srisharan.psgtech@gmail.com>
# SPDX-FileCopyrightText: 2025 Rishav Ray Chaudhury <rrcemon@gmail.com>
#
# SPDX-License-Identifier: GPL-3.0-or-later
#=============================================================================

set(
    HEADER_LIST
    "../include/mankalaengine/mankalaengine.h"
    "../include/mankalaengine/rules.h"
    "../include/mankalaengine/bohnenspielrules.h"
    "../include/mankalaengine/owarerules.h"
    "../include/mankalaengine/pallangulirules.h"
    "../include/mankalaengine/kalahrules.h"
    "../include/mankalaengine/moveselection.h"
    "../include/mankalaengine/variantdescriptions.h")

set(
    PUBLIC_HEADER_LIST
    "${HEADER_LIST}"
    "../include/mankalaengine/mankalaengine_export.h")

add_library(
    MankalaEngine
    mankalaengine.cpp
    rules.cpp
    bohnenspielrules.cpp
    owarerules.cpp
    pallangulirules.cpp
    kalahrules.cpp
    moveselection.cpp
    ${HEADER_LIST})

include(GenerateExportHeader)
generate_export_header(MankalaEngine)
file(
    COPY
    ${CMAKE_CURRENT_BINARY_DIR}/mankalaengine_export.h
    DESTINATION
    ${PROJECT_SOURCE_DIR}/include/mankalaengine)

target_include_directories(
    MankalaEngine PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include/mankalaengine>
    $<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR}/mankalaengine>)

set_target_properties(MankalaEngine PROPERTIES 
    PUBLIC_HEADER "${PUBLIC_HEADER_LIST}"
    VERSION ${PROJECT_VERSION}
    SOVERSION ${PROJECT_VERSION_MAJOR}
)
if(CLANG_TIDY_COMMAND)
    set_target_properties(MankalaEngine PROPERTIES CXX_CLANG_TIDY "${CLANG_TIDY_COMMAND}")
endif()
if(CPPCHECK_COMMAND)
    set_target_properties(MankalaEngine PROPERTIES CXX_CPPCHECK "${CPPCHECK_COMMAND}")
endif()

install(
    TARGETS MankalaEngine
    EXPORT MankalaEngineTargets
    PUBLIC_HEADER DESTINATION "${KDE_INSTALL_INCLUDEDIR}/mankalaengine"
    ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

install(
    EXPORT MankalaEngineTargets
    NAMESPACE MankalaEngine::
    FILE MankalaEngineConfig.cmake
    DESTINATION "${KDE_INSTALL_LIBDIR}/cmake/mankalaengine")

=== test/CMakeLists.txt ===
#=============================================================================
# SPDX-FileCopyrightText: 2024 João Gouveia <jtalonegouveia@gmail.com>
#
# SPDX-License-Identifier: GPL-3.0-or-later
#=============================================================================

include(ECMAddTests)
file(GLOB_RECURSE TEST_FILES Test*.cpp)
ecm_add_tests(${TEST_FILES} LINK_LIBRARIES MankalaEngine Qt6::Test)

## mankalaengine 1.1.0+p24.04+vunstable+git20260103.0354

=== debian/changelog ===
mankalaengine (1.1.0+p24.04+vunstable+git20260103.0354-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sat, 03 Jan 2026 03:54:06 +0000

mankalaengine (1.1.0-0neon) noble; urgency=medium

  * Initial packaginging

 -- Neon CI <neon@kde.org>  Sat, 03 Jan 2026 12:20:29 +1000

=== debian/control ===
Source: mankalaengine
Section: libs
Priority: optional
Uploaders: KDE neon <neon@kde.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               graphviz,
               kf6-extra-cmake-modules,
               pkg-kde-tools-neon,
               qt6-base-dev,
               qt6-tools-dev
Standards-Version: 4.6.2
Homepage: http://games.kde.org/
Vcs-Git: https://invent.kde.org/neon/neon-packaging/mankalaengine.git
Vcs-Browser: https://invent.kde.org/neon/neon-packaging/mankalaengine
Maintainer: Neon CI <neon@kde.org>

Package: libmankalaengine-dev
Section: libdevel
Architecture: any
Depends: libmankalaengine1 (= ${binary:Version}), ${misc:Depends}
Description: development files for the KDE mankalaengine library
 This package contains development files for building software that uses
 the KDE mankalaengine library.
 .
 This package is part of the KDE games module.

Package: libmankalaengine1
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: shared library for KDE based mankala games
 This package contains a shared library to be used by the KDE based mankala
 games.
 .
 This package is part of the KDE games module.

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.sig/ http://download.kde.org/stable/release-service/([\d.]+)/src/mankalaengine-([\d.]+).tar.xz

## mankalaengine 1.1.0+p24.04+vunstable+git20260103.0740

=== debian/changelog ===
mankalaengine (1.1.0+p24.04+vunstable+git20260103.0740-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sat, 03 Jan 2026 07:40:27 +0000

=== debian/control ===
--- 
+++ 
@@ -4,6 +4,7 @@
 Uploaders: KDE neon <neon@kde.org>
 Build-Depends: cmake,
                debhelper-compat (= 13),
+               doxygen,
                graphviz,
                kf6-extra-cmake-modules,
                pkg-kde-tools-neon,
